﻿Imports System.ComponentModel
Public Class ItemComparison
    Private Sub ItemComparison_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown

    End Sub

    Private Sub StartButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartButton.Click
        If SlotCombo.Text <> "" Then
            StartButton.Enabled = False
            SlotCombo.Enabled = False
            DGV.Rows.Clear()
            Dim itemSlot As String = SlotCombo.Text

            ' Store current values.
            Dim savedGear As String = Variables.CurrentGear.Item(itemSlot)
            Dim savedGem As String = Variables.CurrentGems.Item(itemSlot)
            ' Run a baseline DPS test.
            Armory.processGearInfo()
            Form1.updateRatings()
            Form1.preRunTasks()
            Other.doModelRun()
            ' Can use the TenBox result parser to get the DPS value.
            Dim storedDPS As Integer = Other.parseTenResults

            ' Loop through available gear.
            Dim selHash As New Hashtable()
            selHash = getHashTable(itemSlot)
            Dim setItem As DictionaryEntry
            For Each setItem In selHash
                If setItem.Value <> savedGear Then
                    ' Set item as current gear.
                    Variables.CurrentGear.Item(itemSlot) = setItem.Value
                    ' Check for gems.
                    Dim gem0 As String = "0"
                    Dim gem1 As String = "0"
                    Dim gem2 As String = "0"
                    Dim h() As String = Split(setItem.Value, ";")
                    If h(5) <> "0" Or h(5) <> "" Then gem0 = getGem(h(5))
                    If h(6) <> "0" Or h(6) <> "" Then gem1 = getGem(h(6))
                    If h(7) <> "0" Or h(7) <> "" Then gem2 = getGem(h(7))
                    ' Set gems, or blank out if no sockets.
                    Variables.CurrentGems.Item(itemSlot) = gem0 & ";" & gem1 & ";" & gem2

                    ' See if there is a belt buckle we need to account for.
                    If itemSlot = "Waist" And Variables.CurrentEnchants.Item("Waist") = "1230012" Then
                        ' Find an empty slot to put the prismatic in.
                        If h(5) = "0" Or h(5) = "" Then
                            gem0 = getGem("99")
                        ElseIf h(6) = "0" Or h(6) = "" Then
                            gem1 = getGem("99")
                        ElseIf h(7) = "0" Or h(7) = "" Then
                            gem2 = getGem("99")
                        End If
                    End If
                    ' Update gear/stats.
                    Armory.processGearInfo()
                    Form1.updateRatings()
                    Form1.preRunTasks()
                    Other.doModelRun()
                    ' Difference from current DPS to comparision DPS.
                    Dim newdps As Integer = CInt(Other.parseTenResults())
                    Dim changedDPS As Integer = newdps - storedDPS

                    If (UpgradeOnly.Checked = True And changedDPS > 0) Or UpgradeOnly.Checked = False Then
                        Dim inti As Integer = 0
                        Dim spirit As Integer = 0
                        Dim crit As Integer = 0
                        Dim haste As Integer = 0
                        Dim hit As Integer = 0
                        Dim mastery As Integer = 0
                        Dim sp As Integer = 0
                        Dim rItem As String() = Split(setItem.Value, ";")
                        If rItem(9) <> "" Then inti = CInt(rItem(9))
                        If rItem(11) <> "" Then spirit = CInt(rItem(11))
                        If rItem(13) <> "" Then crit = CInt(rItem(13))
                        If rItem(14) <> "" Then haste = CInt(rItem(14))
                        If rItem(12) <> "" Then hit = CInt(rItem(12))
                        If rItem(16) <> "" Then mastery = CInt(rItem(16))
                        If rItem(15) <> "" Then sp = CInt(rItem(15))
                        DGV.Rows.Add(rItem(2), changedDPS, inti, spirit, crit, haste, hit, mastery, sp)
                    End If
                End If
            Next
            ' Reset current gear.
            Variables.CurrentGear.Item(itemSlot) = savedGear
            Variables.CurrentGems.Item(itemSlot) = savedGem
            ' Process original gear.
            Armory.processGearInfo()
            Form1.updateRatings()
            Form1.preRunTasks()
            Variables.rawDamage.Clear()
            StartButton.Enabled = True
            SlotCombo.Enabled = True
        End If
    End Sub

    Public Function getHashTable(ByVal itemslot) As Hashtable
        Dim result As New Hashtable
        Select Case itemslot
            Case "Head"
                result = Variables.HeadArray
            Case "Neck"
                result = Variables.NeckArray
            Case "Shoulder"
                result = Variables.ShoulderArray
            Case "Back"
                result = Variables.BackArray
            Case "Chest"
                result = Variables.ChestArray
            Case "Wrist"
                result = Variables.WristArray
            Case "MainHand"
                result = Variables.MainHandArray
            Case "OffHand"
                result = Variables.OffHandArray
            Case "Hands"
                result = Variables.HandsArray
            Case "Waist"
                result = Variables.WaistArray
            Case "Legs"
                result = Variables.LegsArray
            Case "Feet"
                result = Variables.FeetArray
            Case "Finger1"
                result = Variables.FingerArray
            Case "Finger2"
                result = Variables.FingerArray
            Case "Trinket1"
                result = Variables.TrinketArray
            Case "Trinket2"
                result = Variables.TrinketArray
            Case "Relic"
                result = Variables.RelicArray
        End Select
        Return result
    End Function

    Private Function getGem(ByVal color As String) As String
        Dim result As String = "0"
        Select Case color
            Case "1"
                result = Variables.StoredDefMetaGem
            Case "2"
                result = Variables.StoredDefRedGem
            Case "4"
                result = Variables.StoredDefYellowGem
            Case "8"
                result = Variables.StoredDefBlueGem
            Case "99"
                result = Variables.StoredDefPrisGem
        End Select
        Return result
    End Function
End Class


' Notes:
'               ' 0     1   2      3      4          5     6     7       8        9   10     11     12    13    14    15   16           17   
'Items: 		' Slot, ID, name, armor, set bonus, gem1, gem2, gem3, gem bonus, Int, Stam, Spirit, Hit, Crit, Haste, SP, Mastery, Item Level


' Socket 1 = Meta
' Socket 2 = Red
' Socket 4 = Yellow
' Socket 8 = Blue