﻿Imports System.IO

Public Class ItemEditor_Gems
    Friend itemChanged As Boolean = False

    Private Sub ItemEditor_Gems_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
        processComboBox()
    End Sub

    Private Sub GemComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GemComboBox.SelectedIndexChanged
        Dim item() As String = Split(Variables.GemHash_Name.Item(GemComboBox.Text), ";")
        IDTextBox.Text = item(0)
        ColorCombo.Text = getGemColor(item(2))
        SpDmgTextBox.Text = item(3)
        CritTextBox.Text = item(4)
        HitTextBox.Text = item(5)
        HasteTextBox.Text = item(6)
        IntTextBox.Text = item(7)
        StamTextBox.Text = item(8)
        SpiTextBox.Text = item(9)
        MasteryTextBox.Text = item(10)
    End Sub

    Private Sub GemEditSaveButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GemEditSaveButton.Click
        Try
            ' Assemble new item string.
            Dim color As String = getGemId(ColorCombo.Text)
            Dim newstring = IDTextBox.Text & ";" & GemComboBox.Text & ";" & color & ";" & SpDmgTextBox.Text & ";" & CritTextBox.Text & ";" & _
            HitTextBox.Text & ";" & HasteTextBox.Text & ";" & IntTextBox.Text & ";" & StamTextBox.Text & ";" & SpiTextBox.Text & ";" & MasteryTextBox.Text
            ' Update item array.
            Variables.GemHash_Name(GemComboBox.Text) = newstring
            Variables.GemHash_Id(IDTextBox.Text) = newstring
            ' Rewrite item file.
            Dim objWriterArmor As New StreamWriter("data\gem.data", False)
            For Each item In Variables.GemHash_Name
                objWriterArmor.WriteLine(item.value)
            Next
            objWriterArmor.Close()
            itemChanged = True
            MessageBox.Show("Gem saved")
        Catch ex As Exception
            MessageBox.Show("Error while saving:" & vbCrLf & ex.Message)
        End Try
    End Sub

    Private Sub GemEditDeleteButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GemEditDeleteButton.Click
        Try
            ' Delete from item array.
            Variables.GemHash_Name.Remove(GemComboBox.Text)
            Variables.GemHash_Id.Remove(IDTextBox.Text)
            ' Rewrite item file.
            Dim objWriterArmor As New StreamWriter("data\gem.data", False)
            For Each item In Variables.GemHash_Name
                objWriterArmor.WriteLine(item.value)
            Next
            objWriterArmor.Close()
            processComboBox()
            itemChanged = True
            MessageBox.Show("Gem deleted")
        Catch ex As Exception
            MessageBox.Show("Error while deleting:" & vbCrLf & ex.Message)
        End Try
    End Sub

    Private Sub GemEditCloseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GemEditCloseButton.Click
        If (itemChanged = True) Then
            Variables.GemHash_Id.Clear()
            Variables.GemHash_Name.Clear()
            Form1.DefRedGem.Items.Clear()
            Form1.DefBlueGem.Items.Clear()
            Form1.DefYellowGem.Items.Clear()
            Form1.DefMetaGem.Items.Clear()
            Form1.DefPrisGem.Items.Clear()
            DataFiles.loadGemData()
        End If
        Me.Close()
    End Sub

    Private Function getGemColor(ByVal id As String) As String
        Dim result As String = id
        Select Case id
            Case "0"
                result = "Red"
            Case "1"
                result = "Blue"
            Case "2"
                result = "Yellow"
            Case "3"
                result = "Purple"
            Case "4"
                result = "Green"
            Case "5"
                result = "Orange"
            Case "6"
                result = "Meta"
        End Select
        Return result
    End Function

    Private Function getGemId(ByVal color As String) As String
        Dim result As String = color
        Select Case color
            Case "Red"
                result = "0"
            Case "Blue"
                result = "1"
            Case "Yellow"
                result = "2"
            Case "Purple"
                result = "3"
            Case "Green"
                result = "4"
            Case "Orange"
                result = "5"
            Case "Meta"
                result = "6"
        End Select
        Return result
    End Function

    Private Sub processComboBox()
        GemComboBox.Items.Clear()
        Dim item As DictionaryEntry
        For Each item In Variables.GemHash_Name
            GemComboBox.Items.Add(item.Key)
        Next
        GemComboBox.Sorted = True
        GemComboBox.Text = ""
    End Sub
End Class

' Notes:
'           0   1    2     3   4   5     6    7    8    9    10
'Gem: 	    id;name;socket;sp;crit;hit;haste;intel;stam;spi;mast

' Colors:

' 0 = Red
' 1 = Blue
' 2 = Yellow
' 3 = Purple
' 4 = Green
' 5 = Orange
' 6 = Meta
